#!/bin/env dls-python
import os, sys, getopt
import csv
import collections

PAR_DIR = os.path.join(__file__, os.pardir)
ROOT_DIR = os.path.dirname(os.path.abspath(PAR_DIR))
APP_DIR = os.path.join(ROOT_DIR, "PandATest")

class ConfigReader(object):
    def __init__(self):
        pass

    def extract_module_config(self, file_name):
        module_config = collections.OrderedDict()
        for line in file(file_name):
            row = line.split()
            try:
                if row and not row[0].startswith("#"):
                    key = row[0]
                    # module_name[key] = row[0]
                    if len(row) == 1:
                        module_config[key] = [(row[0], 0)]
                    else:
                        #if we have more than one entry with different block numbers in the config
                        if key in module_config:
                            module_config[key].append((row[0], row[1]))
                        else:
                            module_config[key] = [(row[0], row[1])]
            except Exception as e:
                print "INVALID ENTRY: ", row, ':', e
        return module_config

    def parse_config_file(self, configfile):
        file = os.path.join(APP_DIR, configfile)
        app_config = self.extract_module_config(file)
        return app_config

def main(argv):
    cfg = ConfigReader()
    configfile = ''
    #read in test config file
    try:
        opts, args = getopt.getopt(argv, "hc:", ["configfile="])
    except getopt.GetoptError:
        print 'config_generator.py -c <configfile>'
        sys.exit(2)
    for opt, arg in opts:
        if opt == '-h':
            print 'config_generator.py -c <configfile>'
        elif opt in ("-c", "--configfile"):
            configfile = arg
    app_config = cfg.parse_config_file(configfile) #this should be a param
    print app_config

if __name__ == '__main__':
    main(sys.argv[1:])
