#!/bin/env dls-python
import PandATest
from collections import OrderedDict


class Sfp(PandATest.PandATest):

    def test_code(self):
        #(cmd, (expected result, +- tolerance of result))
        internal_commands = OrderedDict([
            ('SFP.SOFT_RESET=',     ('OK', 0)),
            ('SFP.SFP_CLK1?',       ('OK=3276', 1)),
            ('SFP.SFP_CLK2?',       ('OK=3276', 1)),
            ('SFP.SFP_CLK3?',       ('OK=3276', 1)),
            ('SFP.LINK1_UP?',       ('OK =1', 0)),
            ('SFP.ERROR1_COUNT?',   ('OK =0', 0)),
            ('SFP.LINK2_UP?',       ('OK =1', 0)),
            ('SFP.ERROR2_COUNT?',   ('OK =0', 0)),
            ('SFP.LINK3_UP?',       ('OK =1', 0)),
            ('SFP.ERROR3_COUNT?',   ('OK =0', 0))
        ])

        for cmd, expected in internal_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

        return not all(self.test_result)
